package tsgo

import (
	"fmt"
	"time"
)

type AnyId uint16
type PluginMessageTarget int

type Ts3FunctionsStruct struct {
	PrintMessage func(uint64, string, PluginMessageTarget)
}

const (
	PLUGIN_MESSAGE_TARGET_SERVER  PluginMessageTarget = 0
	PLUGIN_MESSAGE_TARGET_CHANNEL PluginMessageTarget = 1
)

const (
	PluginName        = "Go Plugin yay"
	PluginVersion     = "1.0"
	PluginAuthor      = "Author"
	PluginDescription = "Description"
)

var (
	Ts3Functions Ts3FunctionsStruct
)

//Ts3pluginInit init plugin function
func Ts3pluginInit() int {
	initDbus()
	return 0
}

//Ts3pluginShutdown shutdown plugin function
func Ts3pluginShutdown() {

}

/*
	Events
*/

// Ts3onClientPokeEvent event
func Ts3onClientPokeEvent(serverConnectionHandlerID uint64, fromClientID AnyId, pokerName string, pokerUniqueIdentity string, message string, ffIgnored int) int {

	notifyPoke(pokerName, message)

	// TODO add correct color and icon
	msg := fmt.Sprintf("[color=blue]<%s> [URL=client://%d/%s]\"%s\"[/URL] pokes you", time.Now().Format("15:04:05"), fromClientID, pokerUniqueIdentity, pokerName)

	if message != "" {
		msg += ": " + message
	}

	msg += "[/color]"

	Ts3Functions.PrintMessage(serverConnectionHandlerID, msg, PLUGIN_MESSAGE_TARGET_SERVER)
	return 1
}
